#
#  UptimeInfo - Converter
#
#  Coded by weazle (c) 2013
#  Support: www.dreambox-tools.info
#
#  This plugin is licensed under the Creative Commons 
#  Attribution-NonCommercial-ShareAlike 3.0 Unported 
#  License. To view a copy of this license, visit
#  http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter to Creative
#  Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
#
#  Alternatively, this plugin may be distributed and executed on hardware which
#  is licensed by Dream Multimedia GmbH.

#  This plugin is NOT free software. It is open source, you are allowed to
#  modify it (if you keep the license), but it may not be commercially 
#  distributed other than under the conditions noted above.
#	

from Components.Converter.Converter import Converter
from Components.Element import cached
from Poll import Poll
import os

class UptimeInfo(Poll, Converter, object):
	def __init__(self, type):
		Converter.__init__(self, type)
		Poll.__init__(self)
		self.poll_interval = 5000
		self.poll_enabled = True

	@cached
	def getText(self):
		try:
			f = open( "/proc/uptime" )
			contents = f.read().split()
			f.close()
		except:
			return "Cannot open uptime file: /proc/uptime"
	 
		total_seconds = float(contents[0])

		MINUTE  = 60
		HOUR    = MINUTE * 60
		DAY     = HOUR * 24

		days    = int( total_seconds / DAY )
		hours   = int( ( total_seconds % DAY ) / HOUR )
		minutes = int( ( total_seconds % HOUR ) / MINUTE )
		seconds = int( total_seconds % MINUTE )

		uptime = ""
		if days > 0:
			uptime += str(days) + " " + (days == 1 and "day" or "days" ) + ", "
		if len(uptime) > 0 or hours > 0:
			uptime += str(hours) + " " + (hours == 1 and "hour" or "hours" ) + ", "
		if len(uptime) > 0 or minutes > 0:
			uptime += str(minutes) + " " + (minutes == 1 and "minute" or "minutes" ) + ", "
		uptime += str(seconds) + " " + (seconds == 1 and "second" or "seconds" )
		uptime = "Uptime:" + " " + uptime

		return uptime;

	text = property(getText)
